subroutine ml(string %select, string %response, coef b, coef cc, coef rho, coef sig, matrix cov, scalar !doanalytic)
	!imillsidx = @wcount(%response)
	
	%seleq = ""
	%reseq = ""
	call eqmake(%select,"b",%seleq)
	call eqmake(%response,"cc",%reseq)
	%seldep = @word(%select,1)
	%resdep = @word(%response,1)

	' set up log likelihood
	!pi = @acos(-1)  ' the constant pie
	
	logl ll1
	ll1.append @byobs
	ll1.append @logl logl1
	
	' index for selection equation
	ll1.append xb0 ={%seleq}
	
	' log probability if not observed
	ll1.append p0 = @cnorm(-xb0)
	ll1.append logp0 = log(p0)
	
	' fitted values from the regression model
	ll1.append xb1 = {%reseq}
	
	' standardized residual from the regression model
	ll1.append u = ({%resdep}-xb1)
	
	
	' index for observed regression model
	ll1.append index = (xb0 + rho(1)/sig(1)*u) / (@sqrt(1-rho(1)*rho(1)))
	
	' log probability if observed
	ll1.append p1= @cnorm(index)
	ll1.append logp1 = -log(2*!pi)/2 - log(sig(1)) - (u/sig(1))^2/2 + log(p1)
	
	%tempnames = "xb0 p0 logp0 xb1 u index p1 logp1 mills0 mills1 "

	if !doanalytic = 1 then	
		'derivative w.r.t. b
		%bderiv = ""
		ll1.append mills0 = @dnorm(-xb0)/p0
		ll1.append mills1 = @dnorm(index)/p1
		for !i=1 to @wcount(%select)-1
			%var = @word(%select,!i+1)
			if @upper(%var) = "C" then
				%var = "1"
			endif
			ll1.append db0_{!i} = {%var}*(-mills0)
			ll1.append db1_{!i} = {%var}*(mills1) / @sqrt(1-rho(1)*rho(1))
			ll1.append db{!i} = @recode({%seldep}=0,db0_{!i},db1_{!i})
			%bderiv = %bderiv + " b(" + @str(!i) + ") " + "db" + @str(!i)
			%tempnames = %tempnames + " db0_" + @str(!i) + " db1_" + @str(!i) + " db" + @str(!i)
		next
		
		'derivative w.r.t. c
		%cderiv = ""
		for !i=1 to @wcount(%response )-1
			%var = @word(%response ,!i+1)
			if @upper(%var) = "C" then
				%var = "1"
			endif
			%ser = "cc(" + @str(!i) + ")*" + %var
			ll1.append dc1_{!i} = {%var}*( u/(sig(1)*sig(1)) - mills1*rho(1)/sig(1) / @sqrt(1-rho(1)*rho(1)) )
			ll1.append dc{!i} = @recode({%seldep}=0,0,dc1_{!i})
			%cderiv = %cderiv + " cc(" + @str(!i) + ") " + "dc" + @str(!i)
			%tempnames = %tempnames + " dc1_" + @str(!i) + " dc" + @str(!i)
		next
		
		'derivative w.r.t. sig
		ll1.append ds1 = u*u/(sig(1)^3) - mills1*rho(1)*u/(sig(1)*sig(1)) / @sqrt(1-rho(1)*rho(1)) - 1/sig(1)
		ll1.append ds = @recode({%seldep}=0,0,ds1)
		%tempnames = %tempnames + " ds1 ds"
		
		'derivative w.r.t. rho
		ll1.append dr1 = mills1 * ( u/sig(1) + rho(1)*xb0) / (@sqrt(1-rho(1)*rho(1)))^3
		ll1.append dr = @recode({%seldep}=0,0,dr1)
		%tempnames = %tempnames + " dr1 dr"
		
		%derivs = %bderiv + " " + %cderiv +" sig(1) ds rho(1) dr"
		ll1.append @deriv {%derivs}
	endif
	
	ll1.append @temp {%tempnames} logl1
	
	' specify contribution to the likelihood (uses new @recode syntax)
	ll1.append logl1 = @recode({%seldep}=0,logp0,logp1)
	
	
	' do MLE and show results
	ll1.ml(showopts, m=1000, c=1e-5)
	
	cov = ll1.@coefcov
	
	d ll1
	
endsub


subroutine eqmake(string %spec, string %coef, string %speceq)
	%speceq = ""
	for !i=1 to @wcount(%spec)-1
		%word = @word(%spec,!i+1)
		if @upper(%word) = "C" then
			%word = "1"
		endif
		%speceq = %speceq +  %coef + "(" + @str(!i) + ")*" + %word + " + "
	next
	%speceq = @left(%speceq,@len(%speceq)-3)
endsub
