subroutine maketable(string %tn, string %coefn, string %covarn, string %select, string %response, string %method, string %smpl, scalar !snobs, scalar !onobs, scalar !df)
	!cols = 5
	!rows = @rows({%coefn}) + 10
	table(!rows,!cols) {%tn}
	{%tn}.setwidth(1) 19
	{%tn}.setwidth(2:5) 10
	{%tn}.setjust(a1:a5) left
	!rowcounter=1
	%title = "Heckman Selection Model ( " + %method + ")"
	{%tn}(!rowcounter,1) = %title
	!rowcounter = !rowcounter + 1
	%datestring = "Date: " + @datestr(@now,"MM/DD/YY") + "   Time: " + @datestr(@now,"HH:MI")
	{%tn}(!rowcounter,1) = %datestring
	!rowcounter=!rowcounter+1
	%samplestr = "Sample: " + %smpl
	{%tn}(!rowcounter,1) = %samplestr
	!rowcounter=!rowcounter+1
	%obsstr = "Included selection observations: " + @str(!snobs)
	{%tn}(!rowcounter,1) = %obsstr
	!rowcounter=!rowcounter+1
	%obsstr = "Included response observations: " + @str(!onobs)
	{%tn}(!rowcounter,1) = %obsstr
	!rowcounter=!rowcounter+1
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	!rowcounter = !rowcounter + 1
	
	
	'--------------Selection Equation
	'column headers
	{%tn}(!rowcounter,1) = "Selection Equation"
	{%tn}.setjust(!rowcounter,1) left
	!rowcounter = !rowcounter + 1
	%title = "Dependent Variable: " + @upper(@word(%select,1))
	{%tn}(!rowcounter,1) = %title
	!rowcounter = !rowcounter + 1
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	{%tn}(!rowcounter,1) = "Variable"
	{%tn}(!rowcounter,2) = "Coefficient"
	{%tn}(!rowcounter,3) = "Std. Error"
	{%tn}(!rowcounter,4) = "t-Statistic"
	{%tn}(!rowcounter,5) = "Prob."
	!rowcounter=!rowcounter+1
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	'row headers
	!temprow = !rowcounter
	for !i = 2 to @wcount(%select)
		{%tn}(!temprow,1) = @upper(@word(%select,!i))
		!temprow = !temprow+1
	next
	
	'coefficients etc..
	for !i=1 to @wcount(%select)-1  
		!coef = {%coefn}(!i)
		!covar = @sqrt({%covarn}(!i,!i))
		!tstat = !coef/!covar
		!pvalue = @tdist(!tstat,!df)
		{%tn}(!rowcounter ,2) = !coef
		{%tn}(!rowcounter,3) = !covar
		{%tn}(!rowcounter,4) = !tstat
		{%tn}(!rowcounter,5) = !pvalue
		!rowcounter = !rowcounter + 1
	next
	
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	!rowcounter = !rowcounter + 1
	
	'--------------Response Equation
	'column headers
	{%tn}(!rowcounter,1) = "Response Equation"
	{%tn}.setjust(!rowcounter,1) left
	!rowcounter = !rowcounter + 1
	%title = "Dependent Variable: " + @upper(@word(%response,1))
	{%tn}(!rowcounter,1) = %title
	!rowcounter = !rowcounter + 1
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	{%tn}(!rowcounter,1) = "Variable"
	{%tn}(!rowcounter,2) = "Coefficient"
	{%tn}(!rowcounter,3) = "Std. Error"
	{%tn}(!rowcounter,4) = "t-Statistic"
	{%tn}(!rowcounter,5) = "Prob."
	!rowcounter=!rowcounter+1
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	'row headers
	!temprow = !rowcounter
	for !i = 2 to @wcount(%response)
		{%tn}(!temprow,1) = @upper(@word(%response,!i))
		!temprow = !temprow+1
	next
	
	'coefficients etc..
	!rowcounter = !rowcounter
	!row = @wcount(%select)-1
	for !i=1 to @wcount(%response)-1
		!j = !i + !row
		!coef = {%coefn}(!j)
		!covar = @sqrt({%covarn}(!j,!j))
		!tstat = !coef/!covar
		!pvalue = @tdist(!tstat,!df)
		{%tn}(!rowcounter ,2) = !coef
		{%tn}(!rowcounter,3) = !covar
		{%tn}(!rowcounter,4) = !tstat
		{%tn}(!rowcounter,5) = !pvalue
		!rowcounter = !rowcounter + 1
	next
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	
	'---------------------Error Summary
	
	!rowcounter = !rowcounter + 1
	{%tn}(!rowcounter,1) = "Variable"
	{%tn}(!rowcounter,2) = "Coefficient"
	{%tn}(!rowcounter,3) = "Std. Error"
	{%tn}(!rowcounter,4) = "t-Statistic"
	{%tn}(!rowcounter,5) = "Prob."
	!rowcounter=!rowcounter+1
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
	'Inverse Mills Ratio
	{%tn}(!rowcounter,1) = "Inv. Mills Ratio"
	!row = @rows({%coefn}) - 2
	!coef = {%coefn}(!row )
	!covar = @sqrt({%covarn}(!row ,!row ))
	!tstat = !coef/!covar
	!pvalue = @tdist(!tstat,!df)
	{%tn}(!rowcounter,2) = !coef
	{%tn}(!rowcounter,3) = !covar
	{%tn}(!rowcounter,4) = !tstat
	{%tn}(!rowcounter,5) = !pvalue
	!rowcounter = !rowcounter + 1
	
	'Sigma
	{%tn}(!rowcounter,1) = "Sigma"
	{%tn}(!rowcounter,2) = {%coefn}(!row+1)
	!rowcounter = !rowcounter + 1
	
	'Rho
	{%tn}(!rowcounter,1) = "Rho"
	{%tn}(!rowcounter,2) = {%coefn}(!row+2)
	!rowcounter = !rowcounter + 1
	
	{%tn}.setlines(!rowcounter) +d
	!rowcounter = !rowcounter + 1
	
endsub

